#!/usr/bin/perl

# script to take Kantronics KPC3+ or 9612+ out of KISS mode
# reads a text file named "kpc-port-config.txt" that contains
# the com port number on the first line and the baud rate on
# the second line
# Last update - May 28, 2012 - Lee Bengston K5DAT

use strict;
use warnings;

my ($PortObj, $comport, $baudrate);

my $confile = "kpc-port-config.txt";

open CON, $confile or die "\nUnable to Open Config File\n\n";

$comport = <CON>;
chomp $comport;
$baudrate = <CON>;
chomp $baudrate;
close(CON);

sleep (2); # Delay here to make sure the port is not still in use

use Win32::SerialPort;

$PortObj = new Win32::SerialPort ($comport);

$PortObj->baudrate($baudrate);
$PortObj->parity("none");
$PortObj->databits(8);
$PortObj->stopbits(1);
$PortObj->handshake("rts");
$PortObj->write_settings;

$PortObj->write(chr(192));
$PortObj->write(chr(255));
$PortObj->write(chr(192));

$PortObj->write(chr(003));
$PortObj->write(chr(003));
$PortObj->write(chr(003));

print "\n\nThe commands were sent to take the TNC out of KISS Mode\n\n";

sleep (2);
