#!/usr/bin/perl

use strict;
use warnings;

my ($confile, $comport, $input, $portnum, $baudnum, $baudrate, @bauds, $bauds);
@bauds = (1200, 2400, 4800, 9600, 19200);

$confile = "kpc-port-config.txt";

print "\n\nThis is the setup routine for K5DAT's scripts designed to\n";
print "put a Kantronics KPC-3+ or KPC-9612+ in KISS mode prior\n";
print "to launching APRS software and take it out of KISS Mode after\n";
print "exiting the application\n\n";
print "This routine does the following:\n\n";
print " - asks the user for the port name and baud rate\n\n";
print " - creates a configuration file and stores the port and rate information\n\n";
print "Press any Key to continue or Control-C to abort\n\n";

my $dummy = <STDIN>;

print "Please enter the number corresponding to the serial port to which\nyour TNC is connected\n\n";
print "1   COM1            7   COM7\n";
print "2   COM2            8   COM8\n";
print "3   COM3            9   COM9\n";
print "4   COM4           10   COM10\n";
print "5   COM5           11   COM11\n";
print "6   COM6           12   COM12\n\n";
print "> ";

$input = 0;
while ($input == 0)  {
  $portnum = <STDIN>;
  chomp $portnum;
  if ($portnum < 1)  {
    print "Invalid Selection\n\n";
  }
  elsif ($portnum > 12)  {
    print "Invalid Selection\n\n";
  }
  else {
    $input = 1;
    $comport = "COM$portnum";
  }
}

print "\n\nFor simplicity, the assumption is that Kantronics TNC's\n";
print "always use 8 Data Bits, One Stop Bit, and No Parity\n\n";

print "Please enter the number corresponding to the baud rate\nof your serial port\n\n";
print "1  1200\n";
print "2  2400\n";
print "3  4800\n";
print "4  9600\n";
print "5  19200\n\n";
print "> ";

$input = 0;
while ($input == 0)  {
  $baudnum = <STDIN>;
  chomp $baudnum;
  if ($baudnum < 1)  {
    print "Invalid Selection\n\n";
  }
  elsif ($baudnum > 11)  {
    print "Invalid Selection\n\n";
  }
  else {
    $input = 1;
    $baudnum = $baudnum - 1;
    $baudrate = $bauds[$baudnum];
  }
}

print "\n\nSelections: $comport, $baudrate Baud\n\n";

open (CONF, ">$confile") || die "can't open config file\n";
print CONF "$comport\n$baudrate\n";
close (CONF);

print "Configuration File Written\n\n";

print "This window will close in 5 seconds\n\n";
sleep (5); 

